=== debian/changelog ===
gfxreconstruct (1.0.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.0.0+dfsg
    - Fix build with GCC-13 (Closes: #1037677)
  * Bump version of libvulkan-dev to >= 1.3.250
  * Fix lintian-overrides syntax

 -- Dylan Aïssi <daissi@debian.org>  Tue, 25 Jul 2023 12:23:07 +0200
